'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeEnv = require('nuke-env');

var _nukeThemeProvider = require('nuke-theme-provider');

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* @jsx createElement */


var Switch = function (_Component) {
  _inherits(Switch, _Component);

  function Switch(props) {
    _classCallCheck(this, Switch);

    var _this = _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    _this.changeHandler = _this.changeHandler.bind(_this);
    return _this;
  }
  // shouldComponentUpdate(nextProps) {
  //   return (
  //     this.props.value !== nextProps.value ||
  //     this.props.disabled !== nextProps.disabled ||
  //     !styleEqual(this.props.themeStyle, nextProps.themeStyle)
  //   );
  // }


  _createClass(Switch, [{
    key: 'handleClick',
    value: function handleClick(e) {
      if (this.props.disabled) {
        return null;
      }
      var newVal = !this.props.value;
      this.props.onValueChange && this.props.onValueChange.call(this, newVal);
    }
  }, {
    key: 'changeHandler',
    value: function changeHandler(e) {
      this.props.onValueChange && this.props.onValueChange(e.value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          type = _props.type,
          value = _props.value,
          disabled = _props.disabled,
          onValueChange = _props.onValueChange,
          themeStyle = _props.themeStyle,
          others = _objectWithoutProperties(_props, ['style', 'type', 'value', 'disabled', 'onValueChange', 'themeStyle']);

      var isIOS = _nukeEnv.appInfo.platform.toLowerCase() === 'ios';

      if (_nukeEnv.isWeex) {
        var nativeProps = {
          style: Object.assign({}, isIOS ? {} : { width: 95, height: 60 }, style),
          checked: value,
          disabled: disabled
        };

        return (0, _rax.createElement)('switch', _extends({}, others, nativeProps, { onChange: this.changeHandler }));
      }

      var styles = themeStyle;

      if (type) {
        isIOS = type === 'iOS';
      }
      var wrapStyle = Object.assign({}, styles.wrap, value ? styles.checkedWrap : styles.uncheckedWrap, disabled ? styles.disabledWrap : {}, disabled ? styles['disabled' + (value ? 'Checked' : 'UnChecked') + 'Wrap'] : {}, style);
      if (isIOS) {
        wrapStyle = Object.assign({}, styles.wrapIOS, value ? styles.checkedWrapIOS : styles.uncheckedWrapIOS, disabled ? styles.disabledWrapIOS : {}, disabled ? styles['disabled' + (value ? 'Checked' : 'UnChecked') + 'WrapIOS'] : {}, style);
      }
      var dotStyle = Object.assign({}, styles.dot, value ? styles.checkedDot : styles.uncheckedDot, disabled ? styles.disabledDot : {});
      if (isIOS) {
        dotStyle = Object.assign({}, styles.dotIOS, value ? styles.checkedDotIOS : styles.uncheckedDotIOS, disabled ? styles.disabledDotIOS : {});
      }
      return (0, _rax.createElement)(
        'span',
        _extends({ onClick: this.handleClick, style: wrapStyle }, others),
        (0, _rax.createElement)('small', { style: dotStyle })
      );
    }
  }]);

  return Switch;
}(_rax.Component);

Switch.displayName = 'Switch';
Switch.defaultProps = {
  disabled: false,
  style: {},
  type: null
};
exports.default = (0, _nukeThemeProvider.connectStyle)(_styles2.default)(Switch);
module.exports = exports['default'];